﻿EnableExplicit

Enumeration
  #file
EndEnumeration

DataSection
  binary_data_start:
  IncludeBinary "data"
  binary_data_end:
EndDataSection

#title = "WAV Looper"
#left = "* "
#right = " — "

Global inc_data_len.i = ?binary_data_end - ?binary_data_start

Procedure.i proceed_file(file_req.s, loop.i)
  If FileSize(file_req) > -1
    If OpenFile(#file, file_req)
      Protected file_len.i = Lof(#file)
      If file_len <= inc_data_len
        PrintN(#left + file_req + #right + "Too Small")
      Else
        file_len - inc_data_len
        FileSeek(#file, file_len)
        Protected *mem = AllocateMemory(inc_data_len)
        If ReadData(#file, *mem, inc_data_len) = inc_data_len
          If loop = 1
            If CompareMemory(*mem, ?binary_data_start, inc_data_len)
              PrintN(#left + file_req + #right + "Already LOOPED")
            Else
              If WriteData(#file, ?binary_data_start, inc_data_len) = inc_data_len
                PrintN(#left + file_req + #right + "LOOPED")
              Else
                PrintN(#left + file_req + #right + "Write Data Error")
              EndIf
            EndIf
          Else
            If CompareMemory(*mem, ?binary_data_start, inc_data_len)
              FileSeek(#file, - inc_data_len, #PB_Relative)
              TruncateFile(#file)
              PrintN(#left + file_req + #right + "UNLOOPED")
            Else
              PrintN(#left + file_req + #right + "Nothing to UNLOOP")
            EndIf
          EndIf
        Else
          PrintN(#left + file_req + #right + "Read Data Error")
        EndIf
        FreeMemory(*mem)
      EndIf
      CloseFile(#file)
    Else
      PrintN(#left + file_req + #right + "Can't Open")
    EndIf
  Else
    PrintN(#left + file_req + #right + "Not Found (or Empty/Directory)")
  EndIf
EndProcedure

Procedure.i select_files(loop.i)
  Protected file_req.s = OpenFileRequester(#title, "", "WAVE Audio (*.wav)|*.wav|All Files (*)|*", 0, #PB_Requester_MultiSelection)
  While file_req
    proceed_file(file_req, loop)
    file_req = NextSelectedFileName()
  Wend
EndProcedure

OpenConsole(#title)
PrintN("!!! BACKUP YOUR FILES FIRST !!!")
PrintN("Press ENTER for select WAV Files for Looping.")
PrintN("Press SPACEBAR for select WAV Files for UnLooping.")
PrintN("Press ESCAPE for exit.")

Repeat
  Define input.s
  input = Inkey()
  If input = Chr(27)
    End
  ElseIf input = Chr(13)
    select_files(1)
  ElseIf input = Chr(32)
    select_files(0)
  EndIf
  Delay(50)
ForEver
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Console
; Folding = -
; EnableUnicode
; EnableXP